<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-comment">-- |</span><span>
</span><span id="line-2"></span><span class="hs-comment">-- Module      : UpdateSentence</span><span>
</span><span id="line-3"></span><span class="hs-comment">--</span><span>
</span><span id="line-4"></span><span class="hs-comment">-- This module contains all the functions that update the 'SentenceState' within</span><span>
</span><span id="line-5"></span><span class="hs-comment">-- the State monad without randomization</span><span>
</span><span id="line-6"></span><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Exercises.UpdateSentence</span><span>
</span><span id="line-7"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Exercises.UpdateSentence.html#initializeCopula"><span class="hs-identifier">initializeCopula</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-8"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#initializeNorNork"><span class="hs-identifier">initializeNorNork</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-9"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#updateTenseAndAspect"><span class="hs-identifier">updateTenseAndAspect</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-10"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#updatePronominalSubjectAndAttribute"><span class="hs-identifier">updatePronominalSubjectAndAttribute</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-11"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#updateSubjectAndAttribute"><span class="hs-identifier">updateSubjectAndAttribute</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-12"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#updateVerb"><span class="hs-identifier">updateVerb</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-13"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#updateNorWithNP"><span class="hs-identifier">updateNorWithNP</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-14"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#updateNorkWithPronoun"><span class="hs-identifier">updateNorkWithPronoun</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-15"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#updateAttributeTagsWith"><span class="hs-identifier">updateAttributeTagsWith</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-16"></span><span>    </span><span class="annot"><a href="Exercises.UpdateSentence.html#updateSubjectTagsWith"><span class="hs-identifier">updateSubjectTagsWith</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-17"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-18"></span><span class="hs-keyword">where</span><span>
</span><span id="line-19"></span><span>
</span><span id="line-20"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.State</span></span><span>
</span><span id="line-21"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.html"><span class="hs-identifier">Features</span></a></span><span>
</span><span id="line-22"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Lexis.html"><span class="hs-identifier">Lexis</span></a></span><span>
</span><span id="line-23"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Syntax.html"><span class="hs-identifier">Syntax</span></a></span><span>
</span><span id="line-24"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">System.Random</span></span><span>
</span><span id="line-25"></span><span>
</span><span id="line-26"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-type">updateStateWith</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-27"></span><span>  </span><span class="hs-special">(</span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-28"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-29"></span><span id="updateStateWith"><span class="annot"><span class="annottext">updateStateWith :: (ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var hs-var">updateStateWith</span></a></span></span><span> </span><span id="local-6989586621679083169"><span class="annot"><span class="annottext">ProtoSentence -&gt; ProtoSentence
</span><a href="#local-6989586621679083169"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((StdGen, ProtoSentence)
 -&gt; (ProtoSentence, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) ProtoSentence
forall s (m :: * -&gt; *) a. MonadState s m =&gt; (s -&gt; (a, s)) -&gt; m a
</span><span class="hs-identifier hs-var">state</span></span><span> </span><span class="annot"><span class="annottext">(((StdGen, ProtoSentence)
  -&gt; (ProtoSentence, (StdGen, ProtoSentence)))
 -&gt; State (StdGen, ProtoSentence) ProtoSentence)
-&gt; ((StdGen, ProtoSentence)
    -&gt; (ProtoSentence, (StdGen, ProtoSentence)))
-&gt; State (StdGen, ProtoSentence) ProtoSentence
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679083167"><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679083167"><span class="hs-identifier hs-var">gen</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679083166"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083166"><span class="hs-identifier hs-var">proto</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-30"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span id="local-6989586621679083165"><span class="annot"><span class="annottext">newSent :: ProtoSentence
</span><a href="#local-6989586621679083165"><span class="hs-identifier hs-var hs-var">newSent</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ProtoSentence -&gt; ProtoSentence
</span><a href="#local-6989586621679083169"><span class="hs-identifier hs-var">f</span></a></span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083166"><span class="hs-identifier hs-var">proto</span></a></span><span> </span><span class="hs-keyword">in</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083165"><span class="hs-identifier hs-var">newSent</span></a></span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">StdGen
</span><a href="#local-6989586621679083167"><span class="hs-identifier hs-var">gen</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083165"><span class="hs-identifier hs-var">newSent</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-31"></span><span>
</span><span id="line-32"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updateTenseAndAspect"><span class="hs-identifier hs-type">updateTenseAndAspect</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-33"></span><span>  </span><span class="annot"><a href="Features.Verbal.html#Tense"><span class="hs-identifier hs-type">Tense</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-34"></span><span>  </span><span class="annot"><a href="Features.Verbal.html#Aspect"><span class="hs-identifier hs-type">Aspect</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-35"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-36"></span><span id="updateTenseAndAspect"><span class="annot"><span class="annottext">updateTenseAndAspect :: Tense -&gt; Aspect -&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateTenseAndAspect"><span class="hs-identifier hs-var hs-var">updateTenseAndAspect</span></a></span></span><span> </span><span id="local-6989586621679083164"><span class="annot"><span class="annottext">Tense
</span><a href="#local-6989586621679083164"><span class="hs-identifier hs-var">tense</span></a></span></span><span> </span><span id="local-6989586621679083163"><span class="annot"><span class="annottext">Aspect
</span><a href="#local-6989586621679083163"><span class="hs-identifier hs-var">aspect</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Tense -&gt; Aspect -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#assignTenseAndAspect"><span class="hs-identifier hs-var">assignTenseAndAspect</span></a></span><span> </span><span class="annot"><span class="annottext">Tense
</span><a href="#local-6989586621679083164"><span class="hs-identifier hs-var">tense</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="#local-6989586621679083163"><span class="hs-identifier hs-var">aspect</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-37"></span><span>
</span><span id="line-38"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updateVerb"><span class="hs-identifier hs-type">updateVerb</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-39"></span><span id="updateVerb"><span class="annot"><span class="annottext">updateVerb :: Lexis -&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateVerb"><span class="hs-identifier hs-var hs-var">updateVerb</span></a></span></span><span> </span><span id="local-6989586621679083161"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083161"><span class="hs-identifier hs-var">verb</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Verb -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyVerb"><span class="hs-identifier hs-var">modifyVerb</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Lexis -&gt; Verb
</span><a href="Lexis.html#getVerbFromLexis"><span class="hs-identifier hs-var">getVerbFromLexis</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083161"><span class="hs-identifier hs-var">verb</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-40"></span><span>
</span><span id="line-41"></span><span class="hs-comment">-- | Update the nork constituent with a 'Pronoun'</span><span>
</span><span id="line-42"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updateNorkWithPronoun"><span class="hs-identifier hs-type">updateNorkWithPronoun</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-43"></span><span id="updateNorkWithPronoun"><span class="annot"><span class="annottext">updateNorkWithPronoun :: NF -&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateNorkWithPronoun"><span class="hs-identifier hs-var hs-var">updateNorkWithPronoun</span></a></span></span><span> </span><span id="local-6989586621679083158"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083158"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#assignPronominalNork"><span class="hs-identifier hs-var">assignPronominalNork</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083158"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-44"></span><span>
</span><span id="line-45"></span><span class="hs-comment">-- | Update the nor constituent with an 'NPConstituent'</span><span>
</span><span id="line-46"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updateNorWithNP"><span class="hs-identifier hs-type">updateNorWithNP</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#NPConstituent"><span class="hs-identifier hs-type">NPConstituent</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-47"></span><span id="updateNorWithNP"><span class="annot"><span class="annottext">updateNorWithNP :: NPConstituent -&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateNorWithNP"><span class="hs-identifier hs-var hs-var">updateNorWithNP</span></a></span></span><span> </span><span id="local-6989586621679083156"><span class="annot"><span class="annottext">NPConstituent
</span><a href="#local-6989586621679083156"><span class="hs-identifier hs-var">np</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NPConstituent -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyNor"><span class="hs-identifier hs-var">modifyNor</span></a></span><span> </span><span class="annot"><span class="annottext">NPConstituent
</span><a href="#local-6989586621679083156"><span class="hs-identifier hs-var">np</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-48"></span><span>
</span><span id="line-49"></span><span class="hs-comment">-- | Update the Subject (nor constituent) with a 'Pronoun' and the</span><span>
</span><span id="line-50"></span><span class="hs-comment">-- attribute with the given 'Lexis' pair.</span><span>
</span><span id="line-51"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updatePronominalSubjectAndAttribute"><span class="hs-identifier hs-type">updatePronominalSubjectAndAttribute</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-52"></span><span>  </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-53"></span><span>  </span><span class="hs-comment">-- | A pair of person names to fill the subject position</span><span>
</span><span id="line-54"></span><span>  </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-55"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-56"></span><span id="updatePronominalSubjectAndAttribute"><span class="annot"><span class="annottext">updatePronominalSubjectAndAttribute :: NF -&gt; (Lexis, Lexis) -&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updatePronominalSubjectAndAttribute"><span class="hs-identifier hs-var hs-var">updatePronominalSubjectAndAttribute</span></a></span></span><span> </span><span id="local-6989586621679083154"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083154"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span id="local-6989586621679083153"><span class="annot"><span class="annottext">(Lexis, Lexis)
</span><a href="#local-6989586621679083153"><span class="hs-identifier hs-var">nouns</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-57"></span><span>  </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; (Lexis, Lexis) -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#assignPronominalSubjectAndAttribute"><span class="hs-identifier hs-var">assignPronominalSubjectAndAttribute</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083154"><span class="hs-identifier hs-var">nf</span></a></span><span> </span><span class="annot"><span class="annottext">(Lexis, Lexis)
</span><a href="#local-6989586621679083153"><span class="hs-identifier hs-var">nouns</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-58"></span><span>
</span><span id="line-59"></span><span class="hs-comment">-- | Update the Subject (nor constituent) and the attribute with the given</span><span>
</span><span id="line-60"></span><span class="hs-comment">-- 'Lexis' elements</span><span>
</span><span id="line-61"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updateSubjectAndAttribute"><span class="hs-identifier hs-type">updateSubjectAndAttribute</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-62"></span><span>  </span><span class="hs-comment">-- | Nor constituent</span><span>
</span><span id="line-63"></span><span>  </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-64"></span><span>  </span><span class="hs-comment">-- | Attribute</span><span>
</span><span id="line-65"></span><span>  </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-66"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-67"></span><span id="updateSubjectAndAttribute"><span class="annot"><span class="annottext">updateSubjectAndAttribute :: Lexis -&gt; Lexis -&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateSubjectAndAttribute"><span class="hs-identifier hs-var hs-var">updateSubjectAndAttribute</span></a></span></span><span> </span><span id="local-6989586621679083151"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083151"><span class="hs-identifier hs-var">subj</span></a></span></span><span> </span><span id="local-6989586621679083150"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083150"><span class="hs-identifier hs-var">attr</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-68"></span><span>  </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Lexis -&gt; Lexis -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#assignSubjectAndAttribute"><span class="hs-identifier hs-var">assignSubjectAndAttribute</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083151"><span class="hs-identifier hs-var">subj</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083150"><span class="hs-identifier hs-var">attr</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-69"></span><span>
</span><span id="line-70"></span><span class="hs-comment">-- | Add the given tag to the attribute constituent</span><span>
</span><span id="line-71"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updateAttributeTagsWith"><span class="hs-identifier hs-type">updateAttributeTagsWith</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-72"></span><span id="updateAttributeTagsWith"><span class="annot"><span class="annottext">updateAttributeTagsWith :: Tag -&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateAttributeTagsWith"><span class="hs-identifier hs-var hs-var">updateAttributeTagsWith</span></a></span></span><span> </span><span id="local-6989586621679083148"><span class="annot"><span class="annottext">Tag
</span><a href="#local-6989586621679083148"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-73"></span><span>  </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Tag -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#addTagToAttribute"><span class="hs-identifier hs-var">addTagToAttribute</span></a></span><span> </span><span class="annot"><span class="annottext">Tag
</span><a href="#local-6989586621679083148"><span class="hs-identifier hs-var">tag</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-74"></span><span>
</span><span id="line-75"></span><span class="hs-comment">-- | Add the given tag to the subject constituent</span><span>
</span><span id="line-76"></span><span class="annot"><a href="Exercises.UpdateSentence.html#updateSubjectTagsWith"><span class="hs-identifier hs-type">updateSubjectTagsWith</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-77"></span><span id="updateSubjectTagsWith"><span class="annot"><span class="annottext">updateSubjectTagsWith :: Tag -&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateSubjectTagsWith"><span class="hs-identifier hs-var hs-var">updateSubjectTagsWith</span></a></span></span><span> </span><span id="local-6989586621679083146"><span class="annot"><span class="annottext">Tag
</span><a href="#local-6989586621679083146"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-78"></span><span>  </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Tag -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#addTagToSubject"><span class="hs-identifier hs-var">addTagToSubject</span></a></span><span> </span><span class="annot"><span class="annottext">Tag
</span><a href="#local-6989586621679083146"><span class="hs-identifier hs-var">tag</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-79"></span><span>
</span><span id="line-80"></span><span class="hs-comment">-- | Initialize the 'ProtoSentence' in the state with copula compatible constituents</span><span>
</span><span id="line-81"></span><span class="hs-comment">-- and features</span><span>
</span><span id="line-82"></span><span class="annot"><a href="Exercises.UpdateSentence.html#initializeCopula"><span class="hs-identifier hs-type">initializeCopula</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-83"></span><span id="initializeCopula"><span class="annot"><span class="annottext">initializeCopula :: State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#initializeCopula"><span class="hs-identifier hs-var hs-var">initializeCopula</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="annot"><span class="annottext">ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#startCopula"><span class="hs-identifier hs-var">startCopula</span></a></span><span>
</span><span id="line-84"></span><span>
</span><span id="line-85"></span><span class="hs-comment">-- | Initialize the 'ProtoSentence' in the state with 'NorNork' compatible constituents</span><span>
</span><span id="line-86"></span><span class="hs-comment">-- and features</span><span>
</span><span id="line-87"></span><span class="annot"><a href="Exercises.UpdateSentence.html#initializeNorNork"><span class="hs-identifier hs-type">initializeNorNork</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">State</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">StdGen</span></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-88"></span><span id="initializeNorNork"><span class="annot"><span class="annottext">initializeNorNork :: State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#initializeNorNork"><span class="hs-identifier hs-var hs-var">initializeNorNork</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; State (StdGen, ProtoSentence) ProtoSentence
</span><a href="Exercises.UpdateSentence.html#updateStateWith"><span class="hs-identifier hs-var">updateStateWith</span></a></span><span> </span><span class="annot"><span class="annottext">ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#startNorNork"><span class="hs-identifier hs-var">startNorNork</span></a></span><span>
</span><span id="line-89"></span><span>
</span><span id="line-90"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-91"></span><span class="hs-comment">-- Helpers</span><span>
</span><span id="line-92"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-93"></span><span class="annot"><a href="Exercises.UpdateSentence.html#assignPronominalSubjectAndAttribute"><span class="hs-identifier hs-type">assignPronominalSubjectAndAttribute</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-94"></span><span>  </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-95"></span><span>  </span><span class="hs-comment">-- | A pair of person names to fill the subject position</span><span>
</span><span id="line-96"></span><span>  </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-97"></span><span>  </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-98"></span><span>  </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-99"></span><span id="assignPronominalSubjectAndAttribute"><span class="annot"><span class="annottext">assignPronominalSubjectAndAttribute :: NF -&gt; (Lexis, Lexis) -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#assignPronominalSubjectAndAttribute"><span class="hs-identifier hs-var hs-var">assignPronominalSubjectAndAttribute</span></a></span></span><span> </span><span id="local-6989586621679083142"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083142"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-special">(</span><span id="local-6989586621679083141"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083141"><span class="hs-identifier hs-var">n1</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679083140"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083140"><span class="hs-identifier hs-var">n2</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-100"></span><span>  </span><span class="annot"><span class="annottext">NPConstituent -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyAttribute"><span class="hs-identifier hs-var">modifyAttribute</span></a></span><span> </span><span class="annot"><span class="annottext">NPConstituent
</span><a href="#local-6989586621679083138"><span class="hs-identifier hs-var">attr</span></a></span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; (ProtoSentence -&gt; ProtoSentence)
-&gt; ProtoSentence
-&gt; ProtoSentence
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">NPConstituent -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyNor"><span class="hs-identifier hs-var">modifyNor</span></a></span><span> </span><span class="annot"><span class="annottext">NPConstituent
</span><a href="#local-6989586621679083136"><span class="hs-identifier hs-var">pronoun</span></a></span><span>
</span><span id="line-101"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-102"></span><span>    </span><span id="local-6989586621679083136"><span class="annot"><span class="annottext">pronoun :: NPConstituent
</span><a href="#local-6989586621679083136"><span class="hs-identifier hs-var hs-var">pronoun</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Tag] -&gt; Lexis -&gt; NPConstituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="hs-special">[</span><span class="hs-special">]</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Nominal -&gt; NF -&gt; Lexis
</span><a href="Lexis.html#N"><span class="hs-identifier hs-var">N</span></a></span><span> </span><span class="annot"><span class="annottext">Nominal
</span><a href="Lexis.Noun.html#Pronoun"><span class="hs-identifier hs-var">Pronoun</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083142"><span class="hs-identifier hs-var">f</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-103"></span><span>    </span><span id="local-6989586621679083138"><span class="annot"><span class="annottext">attr :: NPConstituent
</span><a href="#local-6989586621679083138"><span class="hs-identifier hs-var hs-var">attr</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">NF -&gt; Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var hs-var">number</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083142"><span class="hs-identifier hs-var">f</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-104"></span><span>      </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Lexis -&gt; NF -&gt; NPConstituent
</span><a href="Syntax.NominalPhrases.html#np"><span class="hs-identifier hs-var">np</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083141"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083142"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-105"></span><span>      </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Plural"><span class="hs-identifier hs-var">Plural</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">NF -&gt; Lexis -&gt; Lexis -&gt; NPConstituent
</span><a href="Exercises.UpdateSentence.html#makePluralAttribute"><span class="hs-identifier hs-var">makePluralAttribute</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083142"><span class="hs-identifier hs-var">f</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083141"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083140"><span class="hs-identifier hs-var">n2</span></a></span><span>
</span><span id="line-106"></span><span>
</span><span id="line-107"></span><span class="annot"><a href="Exercises.UpdateSentence.html#assignSubjectAndAttribute"><span class="hs-identifier hs-type">assignSubjectAndAttribute</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-108"></span><span>  </span><span class="hs-comment">-- | Subject</span><span>
</span><span id="line-109"></span><span>  </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-110"></span><span>  </span><span class="hs-comment">-- | Attribute</span><span>
</span><span id="line-111"></span><span>  </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-112"></span><span>  </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-113"></span><span>  </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-114"></span><span id="assignSubjectAndAttribute"><span class="annot"><span class="annottext">assignSubjectAndAttribute :: Lexis -&gt; Lexis -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#assignSubjectAndAttribute"><span class="hs-identifier hs-var hs-var">assignSubjectAndAttribute</span></a></span></span><span> </span><span id="local-6989586621679083127"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083127"><span class="hs-identifier hs-var">s</span></a></span></span><span> </span><span id="local-6989586621679083126"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083126"><span class="hs-identifier hs-var">a</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-115"></span><span>  </span><span class="annot"><span class="annottext">NPConstituent -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyAttribute"><span class="hs-identifier hs-var">modifyAttribute</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[Tag] -&gt; Lexis -&gt; NPConstituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="hs-special">[</span><span class="hs-special">]</span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083126"><span class="hs-identifier hs-var">a</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; (ProtoSentence -&gt; ProtoSentence)
-&gt; ProtoSentence
-&gt; ProtoSentence
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">NPConstituent -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyNor"><span class="hs-identifier hs-var">modifyNor</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[Tag] -&gt; Lexis -&gt; NPConstituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="hs-special">[</span><span class="hs-special">]</span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083127"><span class="hs-identifier hs-var">s</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-116"></span><span>
</span><span id="line-117"></span><span class="annot"><a href="Exercises.UpdateSentence.html#assignTenseAndAspect"><span class="hs-identifier hs-type">assignTenseAndAspect</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#Tense"><span class="hs-identifier hs-type">Tense</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Verbal.html#Aspect"><span class="hs-identifier hs-type">Aspect</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-118"></span><span id="assignTenseAndAspect"><span class="annot"><span class="annottext">assignTenseAndAspect :: Tense -&gt; Aspect -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#assignTenseAndAspect"><span class="hs-identifier hs-var hs-var">assignTenseAndAspect</span></a></span></span><span> </span><span id="local-6989586621679083125"><span class="annot"><span class="annottext">Tense
</span><a href="#local-6989586621679083125"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679083124"><span class="annot"><span class="annottext">Aspect
</span><a href="#local-6989586621679083124"><span class="hs-identifier hs-var">a</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Aspect -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyAspect"><span class="hs-identifier hs-var">modifyAspect</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="#local-6989586621679083124"><span class="hs-identifier hs-var">a</span></a></span><span> </span><span class="annot"><span class="annottext">(ProtoSentence -&gt; ProtoSentence)
-&gt; (ProtoSentence -&gt; ProtoSentence)
-&gt; ProtoSentence
-&gt; ProtoSentence
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Tense -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyTense"><span class="hs-identifier hs-var">modifyTense</span></a></span><span> </span><span class="annot"><span class="annottext">Tense
</span><a href="#local-6989586621679083125"><span class="hs-identifier hs-var">t</span></a></span><span>
</span><span id="line-119"></span><span>
</span><span id="line-120"></span><span class="annot"><a href="Exercises.UpdateSentence.html#assignPronominalNork"><span class="hs-identifier hs-type">assignPronominalNork</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-121"></span><span id="assignPronominalNork"><span class="annot"><span class="annottext">assignPronominalNork :: NF -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#assignPronominalNork"><span class="hs-identifier hs-var hs-var">assignPronominalNork</span></a></span></span><span> </span><span id="local-6989586621679083121"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083121"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NPConstituent -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Syntax.ProtoSentence.html#modifyNork"><span class="hs-identifier hs-var">modifyNork</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[Tag] -&gt; Lexis -&gt; NPConstituent
</span><a href="Syntax.Constituent.html#L"><span class="hs-identifier hs-var">L</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Tag
</span><span class="hs-string">&quot;nork&quot;</span></span><span class="hs-special">]</span><span> </span><span class="annot"><span class="annottext">(Lexis -&gt; NPConstituent) -&gt; Lexis -&gt; NPConstituent
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Nominal -&gt; NF -&gt; Lexis
</span><a href="Lexis.html#N"><span class="hs-identifier hs-var">N</span></a></span><span> </span><span class="annot"><span class="annottext">Nominal
</span><a href="Lexis.Noun.html#Pronoun"><span class="hs-identifier hs-var">Pronoun</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083121"><span class="hs-identifier hs-var">nf</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">grammCase :: Case
</span><a href="Features.Nominal.html#grammCase"><span class="hs-identifier hs-var">grammCase</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Case
</span><a href="Features.Nominal.html#Ergative"><span class="hs-identifier hs-var">Ergative</span></a></span><span class="hs-special">}</span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-122"></span><span>
</span><span id="line-123"></span><span class="annot"><a href="Exercises.UpdateSentence.html#makePluralAttribute"><span class="hs-identifier hs-type">makePluralAttribute</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Constituent"><span class="hs-identifier hs-type">Constituent</span></a></span><span>
</span><span id="line-124"></span><span id="makePluralAttribute"><span class="annot"><span class="annottext">makePluralAttribute :: NF -&gt; Lexis -&gt; Lexis -&gt; NPConstituent
</span><a href="Exercises.UpdateSentence.html#makePluralAttribute"><span class="hs-identifier hs-var hs-var">makePluralAttribute</span></a></span></span><span> </span><span id="local-6989586621679083116"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083116"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span id="local-6989586621679083115"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083115"><span class="hs-identifier hs-var">n1</span></a></span></span><span> </span><span id="local-6989586621679083114"><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083114"><span class="hs-identifier hs-var">n2</span></a></span></span><span>
</span><span id="line-125"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Lexis -&gt; Bool
</span><a href="Lexis.html#isAnthroponym"><span class="hs-identifier hs-var">isAnthroponym</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083115"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool -&gt; Bool
</span><span class="hs-operator hs-var">&amp;&amp;</span></span><span> </span><span class="annot"><span class="annottext">Lexis -&gt; Bool
</span><a href="Lexis.html#isAnthroponym"><span class="hs-identifier hs-var">isAnthroponym</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083114"><span class="hs-identifier hs-var">n2</span></a></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-126"></span><span>    </span><span class="annot"><span class="annottext">NPConstituent -&gt; NPConstituent -&gt; NPConstituent
</span><a href="Syntax.NominalPhrases.html#coordNP"><span class="hs-identifier hs-var">coordNP</span></a></span><span>
</span><span id="line-127"></span><span>      </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Lexis -&gt; NF -&gt; NPConstituent
</span><a href="Syntax.NominalPhrases.html#np"><span class="hs-identifier hs-var">np</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083115"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083116"><span class="hs-identifier hs-var">f</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">number :: Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var">number</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span class="hs-special">}</span><span class="hs-special">)</span><span>
</span><span id="line-128"></span><span>      </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Lexis -&gt; NF -&gt; NPConstituent
</span><a href="Syntax.NominalPhrases.html#np"><span class="hs-identifier hs-var">np</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083114"><span class="hs-identifier hs-var">n2</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083116"><span class="hs-identifier hs-var">f</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">number :: Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var">number</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span class="hs-special">}</span><span class="hs-special">)</span><span>
</span><span id="line-129"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Lexis -&gt; Bool
</span><a href="Lexis.html#isAnthroponym"><span class="hs-identifier hs-var">isAnthroponym</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083115"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Lexis -&gt; NF -&gt; NPConstituent
</span><a href="Syntax.NominalPhrases.html#np"><span class="hs-identifier hs-var">np</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083114"><span class="hs-identifier hs-var">n2</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083116"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-130"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Lexis -&gt; NF -&gt; NPConstituent
</span><a href="Syntax.NominalPhrases.html#np"><span class="hs-identifier hs-var">np</span></a></span><span> </span><span class="annot"><span class="annottext">Lexis
</span><a href="#local-6989586621679083115"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679083116"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-131"></span><span>
</span><span id="line-132"></span><span class="annot"><a href="Exercises.UpdateSentence.html#startCopula"><span class="hs-identifier hs-type">startCopula</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-133"></span><span id="startCopula"><span class="annot"><span class="annottext">startCopula :: ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#startCopula"><span class="hs-identifier hs-var hs-var">startCopula</span></a></span></span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="Syntax.ProtoSentence.html#protoCopula"><span class="hs-identifier hs-var">protoCopula</span></a></span><span>
</span><span id="line-134"></span><span>
</span><span id="line-135"></span><span class="annot"><a href="Exercises.UpdateSentence.html#startNorNork"><span class="hs-identifier hs-type">startNorNork</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-136"></span><span id="startNorNork"><span class="annot"><span class="annottext">startNorNork :: ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#startNorNork"><span class="hs-identifier hs-var hs-var">startNorNork</span></a></span></span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="Syntax.ProtoSentence.html#protoNorNork"><span class="hs-identifier hs-var">protoNorNork</span></a></span><span>
</span><span id="line-137"></span><span>
</span><span id="line-138"></span><span class="annot"><a href="Exercises.UpdateSentence.html#addTagToAttribute"><span class="hs-identifier hs-type">addTagToAttribute</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-139"></span><span id="addTagToAttribute"><span class="annot"><span class="annottext">addTagToAttribute :: Tag -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#addTagToAttribute"><span class="hs-identifier hs-var hs-var">addTagToAttribute</span></a></span></span><span> </span><span id="local-6989586621679083108"><span class="annot"><span class="annottext">Tag
</span><a href="#local-6989586621679083108"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span id="local-6989586621679083107"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083107"><span class="hs-identifier hs-var">proto</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083107"><span class="hs-identifier hs-var">proto</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">attribute :: NPConstituent
</span><a href="Syntax.ProtoSentence.html#attribute"><span class="hs-identifier hs-var">attribute</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Tag -&gt; NPConstituent -&gt; NPConstituent
</span><a href="Syntax.Constituent.html#addTag"><span class="hs-identifier hs-var">addTag</span></a></span><span> </span><span class="annot"><span class="annottext">Tag
</span><a href="#local-6989586621679083108"><span class="hs-identifier hs-var">tag</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">ProtoSentence -&gt; NPConstituent
</span><a href="Syntax.ProtoSentence.html#attribute"><span class="hs-identifier hs-var hs-var">attribute</span></a></span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083107"><span class="hs-identifier hs-var">proto</span></a></span><span class="hs-special">)</span><span class="hs-special">}</span><span>
</span><span id="line-140"></span><span>
</span><span id="line-141"></span><span class="annot"><a href="Exercises.UpdateSentence.html#addTagToSubject"><span class="hs-identifier hs-type">addTagToSubject</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Syntax.Constituent.html#Tag"><span class="hs-identifier hs-type">Tag</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Syntax.ProtoSentence.html#ProtoSentence"><span class="hs-identifier hs-type">ProtoSentence</span></a></span><span>
</span><span id="line-142"></span><span id="addTagToSubject"><span class="annot"><span class="annottext">addTagToSubject :: Tag -&gt; ProtoSentence -&gt; ProtoSentence
</span><a href="Exercises.UpdateSentence.html#addTagToSubject"><span class="hs-identifier hs-var hs-var">addTagToSubject</span></a></span></span><span> </span><span id="local-6989586621679083104"><span class="annot"><span class="annottext">Tag
</span><a href="#local-6989586621679083104"><span class="hs-identifier hs-var">tag</span></a></span></span><span> </span><span id="local-6989586621679083103"><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083103"><span class="hs-identifier hs-var">proto</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083103"><span class="hs-identifier hs-var">proto</span></a></span><span> </span><span class="hs-special">{</span><span class="annot"><span class="annottext">norCons :: NPConstituent
</span><a href="Syntax.ProtoSentence.html#norCons"><span class="hs-identifier hs-var">norCons</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Tag -&gt; NPConstituent -&gt; NPConstituent
</span><a href="Syntax.Constituent.html#addTag"><span class="hs-identifier hs-var">addTag</span></a></span><span> </span><span class="annot"><span class="annottext">Tag
</span><a href="#local-6989586621679083104"><span class="hs-identifier hs-var">tag</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">ProtoSentence -&gt; NPConstituent
</span><a href="Syntax.ProtoSentence.html#norCons"><span class="hs-identifier hs-var hs-var">norCons</span></a></span><span> </span><span class="annot"><span class="annottext">ProtoSentence
</span><a href="#local-6989586621679083103"><span class="hs-identifier hs-var">proto</span></a></span><span class="hs-special">)</span><span class="hs-special">}</span><span>
</span><span id="line-143"></span></pre></body></html>